rm(list=ls())

source("SRSPD20170504.R")
library(randtoolbox)
library(DiceDesign)
library(RobustGaSP)
library(tgp)
library(nloptr)

themethod = "TGALC"

p=2
n1=13
n2=26
seed=1
ntrial=1000

f=function(x)
{
  f1=3/4*exp(-.25*(9*x[1]-2)^2-.25*(9*x[2]-2)^2)
  f2=3/4*exp(-1/49*(9*x[1]+1)^2-1/10*(9*x[2]+1)^2)
  f3=1/2*exp(-.25*(9*x[1]-7)^2-.25*(9*x[2]-3)^2)
  f4=1/5*exp(-(9*x[1]-4)^2-(9*x[2]-7)^2)
  val=f1+f2+f3-f4
  return(val)
}

	
PEns = function(design) {
	Y = rep(0,dim(design)[1])
	for(i in 1:dim(design)[1]) Y[i] = f(design[i,1:2])
	A = rgasp(design=design, response=Y)
	set.seed(1)
	testsample = cbind(runif(10000,0,1),runif(10000,0,1))
	realY = rep(0,10000)
	for(i in 1:10000) realY[i] = f(testsample[i,1:2])
	pre = predict(object=A,testing_input=testsample)$mean
	
	mean((pre-realY)^2)
}

sumDist = matrix(0,40,7)
sumPEns = matrix(0,40,7)
sumDist2 = matrix(0,40,7)
sumPEns2 = matrix(0,40,7)

resTG_NT = matrix(0,40,ntrial)
resTG_MNN = matrix(0,40,ntrial)
resTG_FSV = matrix(0,40,ntrial)

# CVa, CVc, CVp, MMLH

seed=1
for(seed in 1:ntrial){


resDist = matrix(0,40,7)
resPEns = matrix(0,40,7)


## TGP-ALC

set.seed(seed)
Dii = lhsDesign(n1,p)$design
Di = maximinSA_LHS(Dii)$design
D = Di
resp = rep(0,n1)
for(i in 1:n1) resp[i] = f(D[i,1:2])

XXcandi = lhsDesign(200,p)$design
XXcand = maximinSA_LHS(XXcandi)$design

# tree1 <- btgp(X = D, Z = resp, pred.n = FALSE, corr = "exp", verb = 0)

# XX <- tgp.design(50, XXcand, tree1)

# tree1.as <- btgp(X = D, Z = resp, XX = XX, corr = "exp", improv = TRUE, Ds2x = TRUE, verb = 0)

# tree1.as$ZZ.q  ## ALM
# tree1.as$Ds2x  ## ALC

# cbind(XX,tree1.as$ZZ.q,tree1.as$Ds2x)

# par(mfrow=c(1,1))
# plot(D,xlim=c(0,1),ylim=c(0,1))
# points(XXcand,pch=4,cex=.5,col='blue')
# points(XX,pch=3,cex=.5,col='green')
# #points(XX[order(-tree1.as$ZZ.q)[1:5],],pch=3,col='yellow')
# points(XX[order(-tree1.as$Ds2x)[1:5],],pch=3,col='yellow')
# #text(x=supp[,1],y=supp[,2],floor(means*1000),col='red')


resDist[n1,1] = min(dist(D))
resPEns[n1,1] = PEns(D)


for(n2 in 1:26){  
	n = dim(D)[1]

	tree1 <- btgp(X = D, Z = resp, pred.n = FALSE, corr = "exp", verb = 0)
	resTG_NT[n1+n2,seed] = length(tree1$trees)
	if(length(tree1$trees)>0) for(kk in 1:length(tree1$trees)) if(!is.null(tree1$trees[[1]])) resTG_MNN[n1+n2,seed] = max(c(resTG_MNN[n1+n2,seed],dim(tree1$trees[[kk]])[1]))
	if(length(tree1$trees)>1) if(!is.null(tree1$trees[[2]])) resTG_FSV[n1+n2,seed] = (tree1$trees[[2]][1,2]=='1') + (tree1$trees[[2]][1,2]=='2')*2 
	XX <- tgp.design(50, XXcand, tree1)
	tree1.as <- btgp(X = D, Z = resp, XX = XX, corr = "exp", improv = TRUE, Ds2x = TRUE, verb = 0)

	# par(mfrow=c(1,1))
	# plot(D,xlim=c(0,1),ylim=c(0,1))
	# points(XXcand,pch=4,cex=.5,col='blue')
	# points(XX,pch=3,cex=.5,col='green')
	# points(XX[order(-tree1.as$Ds2x)[1],2]~XX[order(-tree1.as$Ds2x)[1],1],pch=3,col='red')
	# points(XX[order(-tree1.as$Ds2x)[2:4],],pch=3,col='yellow')
# #	print(tree1$trees)

	addindex = order(-tree1.as$Ds2x)[1]
	D = rbind(D,XX[addindex,])
	resp = c(resp,f(XX[addindex,]))

	resDist[n1+n2,1] = min(dist(D))
	resPEns[n1+n2,1] = PEns(D)
}


## 

resPEns[1,4]=1
sumDist=sumDist+resDist
sumPEns=sumPEns+resPEns
sumDist2=sumDist2+resDist^2
sumPEns2=sumPEns2+resPEns^2
print('')
print('')
print(seed)
print(sumPEns/seed)

write.table(x=sumDist,file=paste('simu3CTGALCFrankeressumDist',p,'.txt',sep=''),quote=FALSE,row.names=FALSE,col.names=FALSE)
write.table(x=sumPEns,file=paste('simu3CTGALCFrankeressumPEns',p,'.txt',sep=''),quote=FALSE,row.names=FALSE,col.names=FALSE)
write.table(x=sumDist,file=paste('simu3CTGALCFrankeressumDist2',p,'.txt',sep=''),quote=FALSE,row.names=FALSE,col.names=FALSE)
write.table(x=sumPEns,file=paste('simu3CTGALCFrankeressumPEns2',p,'.txt',sep=''),quote=FALSE,row.names=FALSE,col.names=FALSE)

write.table(x=resTG_NT,file=paste('simu3CTGALCFrankeresNT',p,'.txt',sep=''),quote=FALSE,row.names=FALSE,col.names=FALSE)
write.table(x=resTG_MNN,file=paste('simu3CTGALCFrankeresMNN',p,'.txt',sep=''),quote=FALSE,row.names=FALSE,col.names=FALSE)
write.table(x=resTG_FSV,file=paste('simu3CTGALCFrankeresFSV',p,'.txt',sep=''),quote=FALSE,row.names=FALSE,col.names=FALSE)
}

resDist=sumDist/ntrial
resPEns=sumPEns/ntrial

write.table(x=resDist,file=paste('simu3CTGALCFrankeresDist',p,'.txt',sep=''),quote=FALSE,row.names=FALSE,col.names=FALSE)
write.table(x=resPEns,file=paste('simu3CTGALCFrankeresPEns',p,'.txt',sep=''),quote=FALSE,row.names=FALSE,col.names=FALSE)
